#ifndef __ili9327_h__
#define __ili9327_h__
//==============================================================================

// control line pins
#define	LCD_CD	PC7
#define	LCD_WR  PC6
#define	LCD_RD  PC5
#define	LCD_CS	PC4
#define	LCD_RES	PC2


// macros for control lines
#define CLR_CD PORTC &= ~(1<<LCD_CD)
#define SET_CD PORTC |=  (1<<LCD_CD)

#define CLR_CS PORTC &= ~(1<<LCD_CS)
#define SET_CS PORTC |=  (1<<LCD_CS)

#define CLR_RESET PORTC &= ~(1<<LCD_RES)
#define SET_RESET PORTC |=  (1<<LCD_RES)

#define CLR_WR PORTC &= ~(1<<LCD_WR)
#define SET_WR PORTC |=  (1<<LCD_WR)

#define CLR_RD PORTC &= ~(1<<LCD_RD)
#define SET_RD PORTC |=  (1<<LCD_RD)

//Data line pins
#define HIGH_BYTE PORTA  //Display Pins DB15-DB8
#define LOW_BYTE  PORTE  //Display Pins DB7-DB0
//==============================================================================
// color definitions
//==============================================================================
//class color_t
//{
//public:
//uint8_t u, l;
//};

//const color_t BLACK   = {0x00, 0x00}; //#define	BLACK	  0x0000
//const color_t BLUE    = {0x00, 0x1F}; //#define	BLUE	  0x001F
//const color_t RED     = {0xF8, 0x00}; //#define	RED 	  0xF800
//const color_t GREEN   = {0x07, 0xE0}; //#define	GREEN   0x07E0
//const color_t CYAN    = {0x07, 0xFF}; //#define CYAN	  0x07FF
//const color_t MAGENTA = {0xF8, 0x1F}; //#define MAGENTA 0xF81F
//const color_t YELLOW  = {0xFF, 0xE0}; //#define YELLOW  0xFFE0
//const color_t WHITE   = {0xFF, 0xFF}; //#define WHITE	  0xFFFF

extern const uint16_t BLACK;
extern const uint16_t BLUE;
extern const uint16_t RED;
extern const uint16_t GREEN;
extern const uint16_t CYAN;
extern const uint16_t MAGENTA;
extern const uint16_t YELLOW;
extern const uint16_t WHITE;

//#define	BLACK	  0x0000
//#define	BLUE	  0x001F
//#define	RED 	  0xF800
//#define	GREEN   0x07E0
//#define CYAN	  0x07FF
//#define MAGENTA 0xF81F
//#define YELLOW  0xFFE0
//#define WHITE	  0xFFFF

//==============================================================================
#define ILI9327_ENTER_SLEEP               (0x10)
#define ILI9327_EXIT_SLEEP                (0x11)
#define ILI9327_DISPLAY_OFF               (0x28)
#define ILI9327_DISPLAY_ON                (0x29)
#define ILI9327_SET_COL_ADDR              (0x2A)
#define ILI9327_SET_PAGE_ADDR             (0x2B)
#define ILI9327_WR_MEM_START              (0x2C)
#define ILI9327_SET_ADDR_MODE             (0x36)
#define ili9327_SET_PIXEL_FORMAT          (0x3A)
#define ILI9327_PANEL_DRIVE_SETTING       (0xC0)
#define ILI9327_DISPLAY_TIMING            (0xC1)
#define ILI9327_DISPLAY_TIMING_IDLE       (0xC3)
#define ILI9327_FRAME_RATE_CONTROL        (0xC5)
#define ILI9327_GAMMA_SETTING             (0xC8)
#define ILI9327_POWER_SETTING             (0xD0)
#define ILI9327_VCOM_CONTROL              (0xD1)
#define ILI9327_POWER_SETTING_NORMAL      (0xD2)
#define ILI9327_3_GAMMA_FUNCTION_CONTROL  (0xEA)
//==============================================================================

void displayColorBars(void);
void displayFillColor(uint16_t data);
void displayHome(void);
void enterStandby(void);
void exitStandby (void);
void writeColor(uint16_t data);
void writeCommand(uint8_t command);
void writeData(uint8_t data);

#endif
